<template>
  <div class="app-container">
    <el-form ref="form" :model="form" :rules="rules" label-width="120px">
      <el-row>
        <el-col :span="8">
          <el-form-item label="工艺路线名称" prop="technologyName">
            <el-input v-model="form.technologyName" maxlength="64" v-if="optType == 'view'"/>
            <el-input v-model="form.technologyName" placeholder="请输入工艺路线名称" maxlength="64" v-else/>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <el-row :gutter="10" class="mb8" v-if="optType !='view'">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['mes:md:mdtechnology:add']"
        >新增</el-button>
        <ItemSelect ref="itemSelect" @onSelected="onItemSelected" > </ItemSelect>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['mes:md:mdtechnology:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="bomList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="工序名称" align="center" prop="processName" />
      <el-table-column label="工序编码" align="center" prop="processCode" />
      <el-table-column label="工时" align="center" prop="workHours" />
      <el-table-column label="备注" align="center" prop="remark" :show-overflow-tooltip="true" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" v-if="optType !='view'">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['mes:md:mditem:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['mes:md:mditem:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import { listBom, getBom, delBom, addBom, updateBom } from "@/api/mes/md/bom";
import ItemSelect  from "@/components/itemSelect/index.vue";
import Treeselect from "@riophae/vue-treeselect";

export default {
  name: "Process",
components: {Treeselect, ItemSelect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 产品BOM关系表格数据
      bomList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        productId: this.productId,
        processId:null,
        processName: null,
        processCode: null,
        workHours: null,
      },
      // 表单参数
      form: {},
    // 表单校验
      rules: {
        quantity: [
          { required: true, message: "物料使用比例不能为空", trigger: "blur" }
        ]
      }
    };
  },
  props: {
      optType: undefined,
      productId: undefined
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询产品BOM关系列表 */
    getList() {
      this.loading = true;
      listBom(this.queryParams).then(response => {
        this.bomList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        productId: this.productId,
        processId:null,
        processName: null,
        processCode: null,
        workHours: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.bomId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
       this.$refs.itemSelect.showFlag = true;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const bomId = row.bomId || this.ids
      getBom(bomId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改产品BOM关系";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
            updateBom(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const bomIds = row.bomId || this.ids;
      this.$modal.confirm('是否确认删除产品BOM关系编号为"' + bomIds + '"的数据项？').then(function() {
        return delBom(bomIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    //物料选择弹出框
    onItemSelected(obj){
        debugger;
        this.form.itemId = this.itemId;
        if(obj != undefined && obj != null){
            obj.forEach(element => {
                this.form.bomItemId = element.itemId;
                this.form.bomItemCode = element.itemCode;
                this.form.bomItemName = element.itemName;
                this.form.bomItemSpec = element.specification;
                this.form.unitOfMeasure = element.unitOfMeasure;
                this.form.itemOrProduct = element.itemOrProduct;
                this.form.quantity = 1;
                this.form.enableFlag = 'Y';
                var retFlag = false;
                addBom(this.form).then(response => {
                    this.$modal.msgSuccess("新增成功");
                    this.getList();
                });
            });
        }
    }
  }
};
</script>
